"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    includeKeys: function() {
        return includeKeys;
    },
    excludeKeys: function() {
        return excludeKeys;
    }
});
function includeKeys(object, predicate) {
    var result = {};
    if (Array.isArray(predicate)) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = predicate[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var key = _step.value;
                var descriptor = Object.getOwnPropertyDescriptor(object, key);
                if (descriptor === null || descriptor === void 0 ? void 0 : descriptor.enumerable) {
                    Object.defineProperty(result, key, descriptor);
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    } else {
        var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
        try {
            // `Reflect.ownKeys()` is required to retrieve symbol properties
            for(var _iterator1 = Reflect.ownKeys(object)[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                var key1 = _step1.value;
                var descriptor1 = Object.getOwnPropertyDescriptor(object, key1);
                if (descriptor1.enumerable) {
                    var value = object[key1];
                    if (predicate(key1, value, object)) {
                        Object.defineProperty(result, key1, descriptor1);
                    }
                }
            }
        } catch (err) {
            _didIteratorError1 = true;
            _iteratorError1 = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                    _iterator1.return();
                }
            } finally{
                if (_didIteratorError1) {
                    throw _iteratorError1;
                }
            }
        }
    }
    return result;
}
function excludeKeys(object, predicate) {
    if (Array.isArray(predicate)) {
        var set = new Set(predicate);
        return includeKeys(object, function(key) {
            return !set.has(key);
        });
    }
    return includeKeys(object, function(key, value, object) {
        return !predicate(key, value, object);
    });
}
